=begin EltenAppInfo
Name=App Dev Sandbox
Version=1.0
Author=grzezlo
=end EltenAppInfo
class Program_AppDevSandbox < Program
  MY_PROGRAM_FILE_NAME = "myprogram.rb"

  def main
    menu = Menu.new
    menu.option("Run my prog") {
      run_my_prog
    }
    menu.option("Exit") {
      finish
    }
    menu.show
  end

  def run_my_prog
    eval(readfile(appfile(MY_PROGRAM_FILE_NAME)))
  rescue Exception => se
    error_my_prog("Error #{se.message}")
  end

  def error_my_prog(errMsg)
    form = Form.new([
      edt_err = EditBox.new("Error", EditBox::Flags::MultiLine | EditBox::Flags::ReadOnly, errMsg, true),
      btn_retry = Button.new("Run again"),
      btn_cancel = Button.new("Cancel"),
    ], 0, false, true)
    btn_retry.on(:press) {
      run_my_prog
      form.resume
    }
    btn_cancel.on(:press) {
      form.resume
    }
    form.cancel_button = btn_cancel
    form.accept_button = btn_retry
    form.wait
  end
end
